#!/usr/bin/perl -w

# Print the features for a decision tree and all "pruned" versions of
# the same decision tree, by chopping off the conditions.

$maxlength = 5;

while(<>)
{
  chomp;
  if (/^$/) { next; }
  @parents = split;
  $child = shift @parents;
  # Apply maximum feature length
  while ($maxlength > 0 && @parents > $maxlength - 1) {
    shift @parents;
  }
  # Print out all subfeatures
  print "$child @parents\n";
  while (@parents > 0) {
    shift @parents;
    print "$child @parents\n";
  }
}
