open Printf

let main () =
  let bn = Bn.load_auto Sys.argv.(1) in
  let features = Mn.to_features (Bn.to_mn bn) in 
  let cond_to_string (sense, var, value) =
    sprintf "%d:%d" var (if sense then value else (1-value)) in
  let print_feature f =
    let s = String.concat " " (List.map cond_to_string f.Mn.Factor.cond) in
    if s <> "" then printf "%s\n" s in 
  List.iter print_feature features

let _ = main ()
