#!/bin/bash
echo "Running tutorial tests..."

testnum=0

if true; then
# TEST 1
testnum=$(($testnum+1))
../../bin/cl -i ../../doc/tutorial/msweb.data -s ../../doc/tutorial/msweb.schema -o out1.xmod -prior 1 -v -log out1.log
diff -q out1.xmod msweb-cl.xmod > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

# TEST 2
testnum=$(($testnum+1))
../../bin/acve -m msweb-cl.xmod -o out2.ac -v -log out2.log
diff -q out2.ac msweb-cl.ac > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

# TEST 3
testnum=$(($testnum+1))
../../bin/aclearnstruct -i ../../doc/tutorial/msweb.data -s ../../doc/tutorial/msweb.schema -o out3.ac -ob out3.xmod -v -log out3.log
diff -q out3.ac msweb-ac.ac > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum-A: Success"; fi
diff -q out3.xmod msweb-ac.xmod > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum-B: Success"; fi

# TEST 4
testnum=$(($testnum+1))
#../../bin/aclearnstruct -i ../../doc/tutorial/msweb.data -s ../../doc/tutorial/msweb.schema -o out4.ac -ob out4.xmod -v -log out4.log -pe 100 -ps 0 -maxe 10000 -shrink
#diff -q out4.ac msweb-ac2.ac > /dev/null
#if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum-A: Success"; fi
#diff -q out4.xmod msweb-ac2.xmod > /dev/null
#if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum-B: Success"; fi

# TEST 5
testnum=$(($testnum+1))
../../bin/mscore -m msweb-cl.xmod -i ../../doc/tutorial/msweb.test -v -log out5.log
diff -q out5.log test5.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

# TEST 6
testnum=$(($testnum+1))
../../bin/mscore -m msweb-cl.ac -i ../../doc/tutorial/msweb.test -v -log out6.log
diff -q out6.log test6.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

# TEST 7
testnum=$(($testnum+1))
../../bin/mscore -m msweb-ac.xmod -i ../../doc/tutorial/msweb.test -v -log out7.log
diff -q out7.log test7.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

# TEST 8
testnum=$(($testnum+1))
../../bin/mscore -m msweb-ac.ac -i ../../doc/tutorial/msweb.test -v -log out8.log
diff -q out8.log test8.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

# TEST 9
testnum=$(($testnum+1))
../../bin/acquery -c msweb-cl.ac -m -v -log out9.log
grep -v " time:" out9.log | diff -q - test9.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

# TEST 10
testnum=$(($testnum+1))
../../bin/acquery -c msweb-cl.ac -v -mo out10.marg -log out10.log
diff -q out10.marg test10.marg > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

# TEST 11
testnum=$(($testnum+1))
../../bin/acquery -c msweb-cl.ac -v -q ./msweb.q -log out11.log
grep -v "time" out11.log | tail -1 | diff -q - test11.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

# TEST 12
testnum=$(($testnum+1))
../../bin/acquery -c msweb-cl.ac -v -q ./msweb.q -ev ./msweb.ev -log out12.log
grep -v "time" out12.log | tail -1 | diff -q - test12.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

# TEST 13
testnum=$(($testnum+1))
../../bin/acquery -c msweb-cl.ac -v -q ./msweb.q -ev ./msweb.ev -m -log out13.log
grep -v "time" out13.log | tail -1 | diff -q - test13.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

#
# MF
#

# TEST 14
testnum=$(($testnum+1))
../../bin/mf -m msweb-cl.xmod -log out14.log -thresh 0.001
diff -q out14.log test14.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

# TEST 15
testnum=$(($testnum+1))
../../bin/mf -m msweb-cl.xmod -q msweb.q -log out15.log -thresh 0.001
diff -q out15.log test15.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

# TEST 16
testnum=$(($testnum+1))
../../bin/mf -m ../../doc/tutorial/msweb.xmod -q msweb.q -ev msweb.ev1 -log out16.log -thresh 0.001
diff -q out16.log test16.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

# TEST 17
testnum=$(($testnum+1))
../../bin/mf -m ../../doc/tutorial/msweb.xmod -q msweb.q -ev msweb.ev1 -log out17.log -sameev -thresh 0.001
grep -v "time" out17.log | diff -q - test17.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

fi

#
# BP
#

# TEST 18
testnum=$(($testnum+1))
../../bin/bp -m msweb-cl.xmod -log out18.log
diff -q out18.log test18.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

# TEST 19
testnum=$(($testnum+1))
../../bin/bp -m msweb-cl.xmod -q msweb.q -log out19.log 
diff -q out19.log test19.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

# TEST 20 
testnum=$(($testnum+1))
../../bin/bp -m ../../doc/tutorial/msweb.xmod -q msweb.q -ev msweb.ev1 -log out20.log 
diff -q out20.log test20.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

# TEST 21 
testnum=$(($testnum+1))
../../bin/bp -m ../../doc/tutorial/msweb.xmod -q msweb.q -ev msweb.ev1 -log out21.log -sameev
diff -q out21.log test21.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi


#
# Gibbs
#

# TEST 22
testnum=$(($testnum+1))
../../bin/gibbs -seed 1234 -m ../../doc/tutorial/msweb.xmod -mo out22.marg
diff -q out22.marg test22.marg > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

# TEST 23 
testnum=$(($testnum+1))
../../bin/gibbs -seed 1234 -m ../../doc/tutorial/msweb.xmod -q msweb.q -ev msweb.ev1 -log out23.log
diff -q out23.log test23.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

# TEST 24
testnum=$(($testnum+1))
../../bin/gibbs -seed 1234 -m ../../doc/tutorial/msweb.xmod -q msweb.q -ev msweb.ev1 -log out24.log -speed medium -sameev
diff -q out24.log test24.log > /dev/null
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

#
# Markov networks and misc.
#

# TEST 25
testnum=$(($testnum+1))
../../bin/mconvert -m ../../doc/tutorial/msweb.xmod -o out25.mn -v -log out25.log
diff -q out25.mn msweb.mn
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

# TEST 26
testnum=$(($testnum+1))
../../bin/bp -m msweb.mn -log out26.log
diff -q out26.log test26.log
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

# TEST 27
testnum=$(($testnum+1))
../../bin/mf -m msweb.mn -ev msweb.ev -log out27.log
diff -q out27.log test27.log
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

# TEST 28
testnum=$(($testnum+1))
../../bin/gibbs -seed 0 -m msweb.mn -q msweb.q -ev msweb.ev -log out28.log
diff -q out28.log test28.log
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

# TEST 29
testnum=$(($testnum+1))
../../bin/mscore -m msweb.mn -i ../../doc/tutorial/msweb.test -v -log out29.log
diff -q out29.log test29.log
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

# TEST 30
testnum=$(($testnum+1))
../../bin/mscore -m ../../doc/tutorial/msweb.xmod -i ../../doc/tutorial/msweb.test -pll -v -log out30.log
diff -q out30.log test30.log
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

# TEST 31
testnum=$(($testnum+1))
../../bin/mconvert -m msweb-cl.xmod -o out31.bif -v -log out31.log
diff -q out31.bif test31.bif
if [ $? -ne 0 ]; then echo "Test $testnum: FAILED"; else echo "Test $testnum: Success"; fi

