
#ifndef RULE_H_NOV_23_2005
#define RULE_H_NOV_23_2005

#include "array.h"
#include "hashint.h"

struct Rule{
  Rule(int rid){
    //cout << "Creating " << rid << endl;
    id = rid;
    value = new Array<int>;
    index = new IntHashArray;


  }
  Rule(const Rule& r){    
    id = -1;
    index = new IntHashArray;
    value = new Array<int>;
    /*
    IntHashArray* oldIndex = r->index;
    Array<int>* oldValue = r->value;
    for(int ix =0; ix < oldValue->size(); ix++){
      index->append((*oldIndex)[ix]);
      value->append((*oldValue)[ix]);
    }
    */
  }



Rule(IntHashArray* idx, Array<int>* val) : index(idx), value(val) {
 
  id = -1;
}
  ~Rule(){
    //cout << "Deleting " << id << endl;
    index->clear();

    value->clear();
    delete index;

    delete value;
  }
  
  int id;
  IntHashArray* index;
  Array<int>* value;


  bool addValue(int val, int position){
    if (index->contains(position)){
      return false;
    }
    else{
      value->append(val);
      index->append(position);
      return true;
    }
  }

  bool covers(Array<int>* example){
    
    for(int ix = 0; ix < index->size(); ix++){
      int pos = (*index)[ix];
      if ((*value)[ix] != (*example)[pos]){
	return false;
      }
      
    }
    return true;
  }
  bool equals(Rule* nRule){
    IntHashArray* idx = nRule->index;  
    Array<int>* val = nRule->value;
    if (idx->size() != index->size()){
      return false;
    }
    for(int ix = 0; ix < index->size(); ix++){
      int pos = idx->find((*index)[ix]);
      if (pos < 0){
 	return false;
      }
      else if ((*val)[pos] != (*value)[pos]){
	return false;
      }
    }
    return true;
  }
  ostream& print(ostream& out) const
  {
    for(int ix = 0; ix < index->size(); ix++){
      out << (*index)[ix] << ":" << (*value)[ix] << " ";
    }

    out << " RID " << id;
    return out;
  }

  ostream& printMLN(ostream& out) const
  {
    for(int ix = 0; ix < index->size(); ix++){
      if ((*value)[ix] == 1){
	out << "P" << (*index)[ix] << "(id1)";// << (*value)[ix] << " ";
      }
      else{
	out << "!P" << (*index)[ix] << "(id1)";// << (*value)[ix] << " ";
      }
      if (ix < index->size()-1){
	out << " ^ ";
      }
    }
    return out;
  }

};

#endif
